// u_types_constants
// 03 mar 00

// -- do NOT add display (used by ADO, ASP)
(*$r+*)

unit u_types_constants;
  interface
    uses Windows; // dWord

    // uses classes;

    const k_tabulation= chr(9);
          k_line_feed= char(10);
          k_return= chr(13);
          k_back_space= chr(8);
          k_escape= chr(27);
          k_pseudo_space= '';

          k_blanks= [k_tabulation, ' '];
          k_blanks_pseudo= k_blanks+ [k_pseudo_space];
          k_returns= [k_return, k_line_feed];

          k_letters= ['a'..'z', 'A'..'Z'];
          k_digits= ['0'..'9'];
          k_digits_underscore= ['0'..'9', '_'];
          k_upper_hex_digits= k_digits+ ['A'..'F'];
          k_hex_digits= k_upper_hex_digits+ ['a'..'f'];

          // k_upper_lower_hex_digits= k_hex_digits+ k_upper_hex_digits;

          k_accents= ['', '', '', '', '', '', '', '', '', ''];
              //  (239 $EF    - 235 $  EB     192 $  C0     194 $  C2 )
          k_lower_traema= ['', '', '', ''];
          k_upper_traema= ['', '', '', ''];
          k_traema= k_lower_traema+ k_upper_traema;
          k_upper_accents= ['', '', '', '', '', '', '', '', '', '' ];
          k_oe= ['', ''];

          k_text_letters= k_letters+ k_accents+ k_traema+ k_upper_accents+ k_oe;

          k_french_punctuations= ['.', ';', ':', '-', '(', ')', '?', '!', '''', '"', '=', '_', ' '];
(*

156 $  9C 

246 $  F6 

200 $C8 
201 $  C9 
202 $  CA 

198 $  C6 

199 $  C7 

203 $  CB 
206 $  CE 
207 $  CF 
212 $  D4 
214 $  D6 

217 $  D9 
219 $  DB 

252 $  FC 
*)
          k_pascal_identifier_start= k_letters+ ['_'];
          k_pascal_identifier_middle= k_pascal_identifier_start+ k_digits;

          k_return_line_feed= k_return+ k_line_feed;
          k_new_line= k_return+ k_line_feed;

          k_blanks_returns= k_blanks+ k_returns;
          k_blanks_pseudo_returns= k_blanks_pseudo+ k_returns;

          k_ord_linefeed= 10;
          // k_ord_line_feed= 10;
          k_ord_return= 13;
          k_ord_tabulation= 9;
          k_ord_space= 32;
          k_ord_returns= [k_ord_linefeed, k_ord_return];
          k_ord_digits= [Ord('0')..Ord('9')];
          k_ord_letters= [Ord('a')..Ord('z'), Ord('A')..Ord('Z')];

          k_word_max= 65534;

          k_hex_digit_string= '0123456789ABCDEF';

    type t_characters= array[0..0] of Char;
         t_pt_characters= ^t_characters;

         t_pt_character= ^Char;
         t_pt_string= ^String;

         t_pt_byte= ^Byte;

         t_bytes= array[0..0] of Byte;
         t_pt_bytes= ^t_bytes;

         t_pt_double= ^Double;
         t_pt_integer= ^Integer;
         t_pt_Word= ^Word; // 16 bits
         t_pt_dWord= ^dWord;
         t_pt_boolean= ^Boolean;

         t_oa_bytes= array of Byte;
         t_oa_characters= array of Char;
         t_oa_integers= array of Integer;
         t_oa_doubles= array of double;

         t_oa_char= Array of Char;
         t_oa_oa_char= Array Of array of char;

         t_oa_double= array of Double;
         t_oa_oa_double= array of array of Double;
         t_oa_oa_oa_double= array of array of array of Double;
         t_oa_integer= array of Integer;
         t_oa_string= array of String;
         t_oa_oa_string= array of array of string;
         t_oa_object= array of tObject;
         t_oa_boolean= Array of Boolean;
         
         t_pt_oa_integers= ^t_oa_integers;

         t_integer_array= array of Integer;
         t_byte_array= array of Byte;
         t_boolean_array= array of Boolean;
         t_double_array= array of Double;
         t_double_matrix= array of array of Double;

         t_pt_double_array= ^t_double_array;

         t_handle_procedure= procedure(p_pt: Pointer);

         t_string_4= String[4];

         // -- CAUTION also in u_character
         t_set_of_characters= Set of Char;
         t_set_of_char= Set of Char;
         t_set_of_bytes= Set of Byte;
         t_character_set= Set of Char;
         t_byte_set= set of byte;

         t_byte_date= packed record
                               m_day, m_month, m_year: byte;
                             end;
         t_date_4= packed record
                            m_day, m_month: byte;
                            m_year: Integer;
                          end;

    function f_TF_to_boolean(p_TF: String): Boolean;
    function f_display_byte_set(p_byte_set: t_set_of_bytes): String;

  implementation
    Uses SysUtils;

    function f_TF_to_boolean(p_TF: String): Boolean;
      begin
        Result:= LowerCase(p_TF)= 't';
      end; // f_TF_to_boolean

    function f_display_byte_set(p_byte_set: t_set_of_bytes): String;
      var l_byte: Byte;
      begin
        Result:= '';
        for l_byte:= 0 to 255 do
          if l_byte In p_byte_set
            then begin
                if Result<> ''
                  then Result:= Result+ ' ';
                Result:= Result+ IntToStr(l_byte);
              end;
      end; // f_display_byte_set

    begin
    end.

















































































